#!/usr/bin/env node
var minimist = require('minimist');
var extend = require('xtend');
var typings_1 = require('../typings');
var cli_1 = require('../utils/cli');
var config_1 = require('../utils/config');
var args = minimist(process.argv.slice(2), {
    boolean: ['save', 'saveAmbient', 'saveDev', 'ambient', 'verbose', 'help'],
    alias: {
        save: ['S'],
        saveAmbient: ['A', 'save-ambient'],
        saveDev: ['save-dev', 'D'],
        name: ['n'],
        ambient: ['a'],
        verbose: ['v'],
        help: ['h']
    }
});
if (args.help) {
    console.log("\n" + config_1.PROJECT_NAME + " uninstall <pkg> [--ambient] [--save|--save-dev|--save-ambient]\n\nAliases: r, rm, remove, un\n");
    process.exit(0);
}
var options = extend(args, { cwd: process.cwd() });
if (args._.length) {
    cli_1.loader(typings_1.uninstallDependency(args._[0], options), options);
}
//# sourceMappingURL=typings-uninstall.js.map