var extend = require('xtend');
var invariant = require('invariant');
var fs_1 = require('./utils/fs');
var find_1 = require('./utils/find');
function uninstallDependency(name, options) {
    var ambient = options.saveAmbient || options.ambient;
    function uninstall(options) {
        return fs_1.removeDependency(options).then(function () { return writeToConfig(name, options); });
    }
    return find_1.findProject(options.cwd)
        .then(function (cwd) { return uninstall(extend(options, { cwd: cwd, name: name, ambient: ambient })); }, function () { return uninstall(extend(options, { name: name, ambient: ambient })); });
}
exports.uninstallDependency = uninstallDependency;
function writeToConfig(name, options) {
    if (!options.save && !options.saveDev && !options.saveAmbient) {
        return;
    }
    invariant((options.save || options.saveDev) && (options.ambient || options.saveAmbient), '--save and --save-dev are incompatible with ambient dependencies');
    return fs_1.transformConfig(options.cwd, function (config) {
        if (options.save && config.dependencies) {
            delete config.dependencies[name];
        }
        if (options.saveDev && config.devDependencies) {
            delete config.devDependencies[name];
        }
        if (options.saveAmbient && config.ambientDependencies) {
            delete config.ambientDependencies[name];
        }
        return config;
    });
}
//# sourceMappingURL=uninstall.js.map